﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;
using System.IO;

using ICSharpCode.SharpZipLib.GZip;

namespace Umc.Core.Web.HttpCompression
{
	/// <summary>
	/// Umc.Core<br/>
	/// GZip 압축 알고리즘 클래스 입니다.
	/// </summary>
	public sealed class GZipCompression : IHttpCompressionAlgorism
	{

		#region IHttpCompressionAlgorism 멤버

		/// <summary>
		/// Umc.Core<br/>
		/// 압축 알고리즘을 구현합니다.
		/// </summary>
		/// <param name="outputStream">출력 스트림입니다.</param>
		/// <param name="level">압축율을 지정합니다.</param>
		/// <returns></returns>
		public Stream CompressionAlgorism(Stream outputStream, HttpCompressionLevel level)
		{
			GZipOutputStream stream = new GZipOutputStream(outputStream);
			stream.SetLevel((int)level);
			return stream;
		}

		/// <summary>
		/// 압축된 스트림이 내보내질 Content-Encoding 입니다.
		/// </summary>
		public string ContentEncoding
		{
			get { return "gzip"; }
		}

		#endregion
	}
}
